%if 0%{?fedora}
%global py2 2
# XXX - No python3 support for now until python3-jira is available.  Working on it!
%global with_python3 0
%else
# On EL7 define %%{py2} as the empty string.
%define py2 %{nil}
%endif

%{!?_licensedir: %global license %%doc}

%global modname sync2jira
%global sum     Sync pagure and github issues to jira, via fedmsg

Name:               python-sync2jira
Version:            1.5
Release:            1%{?dist}
Summary:            %{sum}

License:            LGPLv2+
URL:                https://pypi.io/pypi/sync2jira
Source0:            https://pypi.io/packages/source/s/%{modname}/%{modname}-%{version}.tar.gz
BuildArch:          noarch

BuildRequires:      systemd

BuildRequires:      python%{py2}-devel
BuildRequires:      python%{py2}-setuptools
BuildRequires:      python%{py2}-fedmsg-core
BuildRequires:      python%{py2}-requests
BuildRequires:      python%{py2}-nose
BuildRequires:      python%{py2}-mock
BuildRequires:      python%{py2}-arrow
%if 0%{?fedora}
#BuildRequires:      python%%{py2}-jira
BuildRequires:      python-jira
%endif

%if 0%{?with_python3}
BuildRequires:      python3-devel
BuildRequires:      python3-setuptools
BuildRequires:      python3-fedmsg-core
BuildRequires:      python3-requests
BuildRequires:      python3-nose
BuildRequires:      python3-mock
BuildRequires:      python3-jira
BuildRequires:      python3-arrow
%endif

%description
This is a process that listens to activity on upstream repos on pagure and
github via fedmsg, and syncs new issues there to a Jira instance elsewhere.

Configuration is in /etc/fedmsg.d/. You can maintain a mapping there that
allows you to match one upstream repo (say, 'pungi' on pagure) to a downstream
project/component pair in Jira (say, 'COMPOSE', and 'Pungi').

%package -n python2-%{modname}
Summary:            %{sum}
%{?python_provide:%python_provide python2-%{modname}}

Requires:           python%{py2}-requests
Requires:           python%{py2}-fedmsg-core
%if 0%{?fedora}
#Requires:           python%%{py2}-jira
Requires:           python-jira
%endif

%description -n python2-%{modname}
This is a process that listens to activity on upstream repos on pagure and
github via fedmsg, and syncs new issues there to a Jira instance elsewhere.

Configuration is in /etc/fedmsg.d/. You can maintain a mapping there that
allows you to match one upstream repo (say, 'pungi' on pagure) to a downstream
project/component pair in Jira (say, 'COMPOSE', and 'Pungi').

%if 0%{?with_python3}
%package -n python3-%{modname}
Summary:            %{sum}
%{?python_provide:%python_provide python3-%{modname}}

Requires:           python3-requests
Requires:           python3-jira
Requires:           python3-fedmsg-core

%description -n python3-%{modname}
This is a process that listens to activity on upstream repos on pagure and
github via fedmsg, and syncs new issues there to a Jira instance elsewhere.

Configuration is in /etc/fedmsg.d/. You can maintain a mapping there that
allows you to match one upstream repo (say, 'pungi' on pagure) to a downstream
project/component pair in Jira (say, 'COMPOSE', and 'Pungi').
%endif

%prep
%autosetup -n %{modname}-%{version}

# The egg name is all screwy here...
sed -i '/jira/d' requirements.txt

# Remove shebang from main.py
sed -i '/\/usr\/bin\/env/d' sync2jira/main.py

# Remove upstream's egg-info
rm -rf *.egg*

%build
%py2_build
%if 0%{?with_python3}
%py3_build
%endif

%install
%py2_install
%if 0%{?with_python3}
%py3_install
%endif

%{__mkdir_p} %{buildroot}%{_unitdir}
%{__install} -pm644 systemd/sync2jira.service \
    %{buildroot}%{_unitdir}/sync2jira.service

%check
%{__python2} setup.py test
%if 0%{?with_python3}
%{__python3} setup.py test
%endif

%files -n python2-%{modname}
%doc README.rst
%license LICENSE
%{python2_sitelib}/%{modname}/
%{python2_sitelib}/%{modname}-%{version}*
%{_bindir}/sync2jira
%{_bindir}/sync2jira-list-managed-urls
%{_bindir}/sync2jira-close-duplicates
%{_unitdir}/sync2jira.service

%if 0%{?with_python3}
%files -n python3-%{modname}
%doc README.rst
%license LICENSE
%{python3_sitelib}/%{modname}/
%{python3_sitelib}/%{modname}-%{version}*
%endif

%changelog
* Thu Oct 05 2017 Ralph Bean <rbean@redhat.com> - 1.5-1
- new version

* Fri Sep 29 2017 Ralph Bean <rbean@redhat.com> - 1.4-1
- new version

* Thu Sep 14 2017 Ralph Bean <rbean@redhat.com> - 1.3-1
- new version

* Sat Aug 19 2017 Ralph Bean <rbean@redhat.com> - 1.2-1
- new version

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Mon May 15 2017 Ralph Bean <rbean@redhat.com> - 1.1-1
- new version

* Mon Feb 13 2017 Ralph Bean <rbean@redhat.com> - 1.0-1
- new version

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.4-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Fri Oct 07 2016 Ralph Bean <rbean@redhat.com> - 0.4-1
- new version

* Thu Oct 06 2016 Ralph Bean <rbean@redhat.com> - 0.3-1
- new version

* Tue Jul 19 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.2-5
- https://fedoraproject.org/wiki/Changes/Automatic_Provides_for_Python_RPM_Packages

* Mon Jun 20 2016 Ralph Bean <rbean@redhat.com> - 0.2-4
- Fix incorrect Requires entry for python-jira.

* Thu Jun 16 2016 Ralph Bean <rbean@redhat.com> - 0.2-3
- Fix incorrect sed statement in prep section.

* Thu Jun 16 2016 Ralph Bean <rbean@redhat.com> - 0.2-2
- Remove shebang from main.py
- Remove upstream's egg-info.
- Escape macros in comments.
- Correct BuildArch tag.

* Wed Jun 15 2016 Ralph Bean <rbean@redhat.com> - 0.2-1
- Latest upstream.
- Include a systemd service file.

* Fri Jun 10 2016 Ralph Bean <rbean@redhat.com> - 0.1-2
- Fix for el7 packaging.

* Tue May 10 2016 Ralph Bean <rbean@redhat.com> - 0.1-1
- Initial packaging for Fedora
